/*******************************************************************************
 *
 * TRIQS: a Toolbox for Research in Interacting Quantum Systems
 *
 * Copyright (C) 2015 by O. Parcollet
 *
 * TRIQS is free software: you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * TRIQS is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * TRIQS. If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************************************/
#include <triqs/test_tools/arrays.hpp>
#include <triqs/arrays.hpp>
using namespace triqs::arrays;

#include <type_traits>
static_assert(!std::is_pod<triqs::arrays::array<long, 2>>::value, "POD pb");

TEST(Array, Print) {

 array<long, 2> A(2, 3), B;

 for (int i = 0; i < 2; ++i)
  for (int j = 0; j < 3; ++j) A(i, j) = 10 * i + j;

 EXPECT_PRINT("\n[[0,1,2]\n [10,11,12]]", A);
}
MAKE_MAIN;
